enum kind {plus, minus, uminus};

struct common{
  enum kind _kind;
};

struct Plus{
  struct common _common;
  Expr *left;
  Expr *right;
};

struct Minus{
  struct common _common;
  Expr *left;
  Expr *right;
};

struct UMinus{
  struct common _common;
  Expr *operand;
};

union Expr{
    struct common _common;
    struct Plus _plus;
    struct Minus _minus;
    struct UMinus _uminus;
};

Expr* make_plus(Expr*l, Expr*r){

  Expr* result = malloc(sizeof(struct Expr));
  result->_common._kind = plus;
  result->_plus.left = l;
  result->_plus.right = r;
  return result;
}


